package com.jeecms.cms.dao.assist.impl;

package ..deTemp.1741585170594;

import com.jeecms.cms.dao.assist.CmsSearchWordsDao;
import com.jeecms.cms.entity.assist.CmsSearchWords;
import com.jeecms.common.hibernate4.Finder;
import com.jeecms.common.hibernate4.HibernateBaseDao;
import com.jeecms.common.hibernate4.Updater;
import com.jeecms.common.page.Pagination;
import com.jeecms.common.util.ChineseCharToEn;
import java.util.List;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Repository;

@Repository
public class CmsSearchWordsDaoImpl extends HibernateBaseDao<CmsSearchWords, Integer> implements CmsSearchWordsDao {
  public Pagination getPage(Integer siteId, String name, Integer recommend, Integer orderBy, int pageNo, int pageSize) {
    Finder f = Finder.create("from CmsSearchWords words where  words.site.id=:siteId")
      .setParam("siteId", siteId);
    if (StringUtils.isNotBlank(name))
      f.append(" and words.name like :name").setParam("name", "%" + name + "%"); 
    if (recommend != null)
      if (recommend.equals(Integer.valueOf(1))) {
        f.append(" and words.recommend=true");
      } else if (recommend.equals(Integer.valueOf(0))) {
        f.append(" and words.recommend=false");
      }  
    if (orderBy != null) {
      if (orderBy.equals(Integer.valueOf(1))) {
        f.append(" order by words.hitCount desc");
      } else if (orderBy.equals(Integer.valueOf(2))) {
        f.append(" order by words.hitCount asc");
      } else if (orderBy.equals(Integer.valueOf(3))) {
        f.append(" order by words.priority desc");
      } else if (orderBy.equals(Integer.valueOf(4))) {
        f.append(" order by words.priority asc");
      } 
    } else {
      f.append(" order by words.hitCount desc");
    } 
    f.setCacheable(true);
    Pagination page = find(f, pageNo, pageSize);
    return page;
  }
  
  public List<CmsSearchWords> getList(Integer siteId, String name, Integer recommend, Integer orderBy, Integer first, Integer count, boolean cacheable) {
    Finder f = Finder.create("from CmsSearchWords words where  words.site.id=:siteId")
      .setParam("siteId", siteId);
    if (StringUtils.isNotBlank(name)) {
      String chineseEn = ChineseCharToEn.getAllFirstLetter(name);
      f.append(" and  (words.name like :name or words.nameInitial like :nameEn)").setParam("name", "%" + name + "%").setParam("nameEn", String.valueOf(chineseEn) + "%");
    } 
    if (recommend != null)
      if (recommend.equals(Integer.valueOf(1))) {
        f.append(" and words.recommend=true");
      } else if (recommend.equals(Integer.valueOf(0))) {
        f.append(" and words.recommend=false");
      }  
    if (orderBy != null) {
      if (orderBy.equals(Integer.valueOf(1))) {
        f.append(" order by words.hitCount desc");
      } else if (orderBy.equals(Integer.valueOf(2))) {
        f.append(" order by words.hitCount asc");
      } else if (orderBy.equals(Integer.valueOf(3))) {
        f.append(" order by words.priority desc");
      } else if (orderBy.equals(Integer.valueOf(4))) {
        f.append(" order by words.priority asc");
      } 
    } else {
      f.append(" order by words.hitCount desc");
    } 
    f.setMaxResults(count.intValue());
    if (first != null)
      f.setFirstResult(first.intValue()); 
    f.setCacheable(cacheable);
    return find(f);
  }
  
  public CmsSearchWords findById(Integer id) {
    CmsSearchWords entity = (CmsSearchWords)get(id);
    return entity;
  }
  
  public CmsSearchWords findByName(String name) {
    Finder f = Finder.create("from CmsSearchWords words where words.name=:name ").setParam("name", name);
    List<CmsSearchWords> li = find(f);
    if ((((li != null) ? 1 : 0) & ((li.size() > 0) ? 1 : 0)) != 0)
      return li.get(0); 
    return null;
  }
  
  public CmsSearchWords save(CmsSearchWords bean) {
    getSession().save(bean);
    return bean;
  }
  
  public CmsSearchWords deleteById(Integer id) {
    CmsSearchWords entity = (CmsSearchWords)get(id);
    if (entity != null)
      getSession().delete(entity); 
    return entity;
  }
  
  protected Class<CmsSearchWords> getEntityClass() {
    return CmsSearchWords.class;
  }
}
